package controller;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.List;


/**
 * Schnittstelle der Funktionen des Clients
 * 
 * Version 1.0.08112013
 * 
 * @author Thomas Kramer, eMail: th-rzv@gmx.de
 * 
 * Bitte beachten: beim hinzufgen von Methoden muss eine RemoteException
 * geworfen werden damit RMI die neuen methoden annimmt!
 * 
 */
public interface ClientInterface extends Remote {
	void update(Class t, List<Object> o, ClientInterface dataInitiator) throws RemoteException;

	void serverTerminated() throws RemoteException;
	
	void setClientIP(String ip) throws RemoteException;
	
	String getClientIP() throws RemoteException;
	
	String getLoginTime() throws RemoteException;
	
	String getUniqueIdentifier() throws RemoteException;
	
	UserRole getUserRole() throws RemoteException;
	
	void closeChangeWindow(Object changeObject, ClientInterface changeObjectRegisteredByUser) throws RemoteException;
}