package controller;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.List;

/**
 * Schnittstelle der Funktionen des Servers
 * 
 * Version 1.0.08112013
 * 
 * @author Thomas Kramer, eMail: th-rzv@gmx.de
 * 
 * Bitte beachten: beim hinzufgen von Methoden muss eine RemoteException
 * geworfen werden damit RMI die neuen methoden annimmt!
 * 
 */
public interface ServerInterface extends Remote {
	String SERVICE_NAME = "Projektverwaltung";

	public void addObserver(ClientInterface remoteObserver)
			throws RemoteException;

	public void removeObserver(ClientInterface remoteObserver)
			throws RemoteException;

	public void selectData(Class tableName, ClientInterface remoteObserver) throws RemoteException;

	public List<Object> getData(Class tableName) throws RemoteException;

	public List<Object> getDataWithClause(Class tableName, String column,
			String clause, boolean caseSensitivity) throws RemoteException;

	public List<Object> getDataWithClause(Class tableName, String column,
			Integer clause) throws RemoteException;

	public boolean insertData(Object object, ClientInterface remoteObserver) throws RemoteException;
	
	public boolean insertDataCollection(List<Object> object, ClientInterface remoteObserver) throws RemoteException;	

	public boolean changeData(Object object, ClientInterface remoteObserver) throws RemoteException;

	public boolean deleteData(Object object, ClientInterface remoteObserver) throws RemoteException;
	
	public void registerChangeObject(Object changeObject, ClientInterface remoteObserver) throws RemoteException;
	
	public void unregisterChangeObject(Object changeObject, ClientInterface remoteObserver) throws RemoteException;
	
	public boolean accessToChangeObjectAllowed(Object changeObject, ClientInterface remoteObserver) throws RemoteException;	
}