package databaseModel;

import javax.persistence.*;
import java.util.List;

/**
 * Abstrakte Basisklasse, nicht in der Datenbank vorhanden.
 * Vererbung auf O/R-Mapper/Datenbankebene siehe hier:
 * 
 * https://en.wikibooks.org/wiki/Java_Persistence/Inheritance
 * 
 */
@MappedSuperclass
public abstract class AbstractEntity implements java.io.Serializable {
	private static final long serialVersionUID = 1L;
	
	public abstract int getId();
	
	public abstract String getName();	
	
	public abstract int getVersion();
	
	public abstract void setVersion(int version);
}
