package databaseModel;

import javax.persistence.*;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.Length;


/**
 * The persistent class for the PROJEKT database table.
 * 
 * Wichtig: aus dem Kommentar-Feld darf kein Pflichtfeld werden!
 * 
 */
@Entity
public class Projekt extends AbstractEntity {
	private static final long serialVersionUID = 1L;
	private int id;
	@Length(max = 300, message="Die Beschreibung darf maximal 300 Zeichen lang sein")
	@NotNull		
	private String beschreibung;
	@Length(max = 300, message="Der Kommentar darf maximal 300 Zeichen lang sein")	
	private String kommentar;
	@Length(max = 15, message="Der Status darf maximal 15 Zeichen lang sein")
	@NotNull		
	private String status;
	@Length(max = 30, message="Der Titel darf maximal 30 Zeichen lang sein")
	@NotNull	
	private String titel;
	@NotNull	
	private Ansprechpartner ansprechpartnerBean;
	@NotNull	
	private Student student1Bean;
	private Student student2Bean;
	private Student student3Bean;

	public Projekt() {
	}

	@Id	
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}


	public String getBeschreibung() {
		return this.beschreibung;
	}

	public void setBeschreibung(String beschreibung) {
		this.beschreibung = beschreibung;
	}


	public String getKommentar() {
		return this.kommentar;
	}

	public void setKommentar(String kommentar) {
		this.kommentar = kommentar;
	}


	public String getStatus() {
		return this.status;
	}

	public void setStatus(String status) {
		this.status = status;
	}
	
	public String getTitel() {
		return this.titel;
	}

	public void setTitel(String titel) {
		this.titel = titel;
	}


	//bi-directional many-to-one association to Ansprechpartner
	@ManyToOne
	@JoinColumn(name="ANSPRECHPARTNER")
	public Ansprechpartner getAnsprechpartnerBean() {
		return this.ansprechpartnerBean;
	}

	public void setAnsprechpartnerBean(Ansprechpartner ansprechpartnerBean) {
		this.ansprechpartnerBean = ansprechpartnerBean;
	}


	//bi-directional many-to-one association to Student
	@ManyToOne
	@JoinColumn(name="STUDENT1")
	public Student getStudent1Bean() {
		return this.student1Bean;
	}

	public void setStudent1Bean(Student student1Bean) {
		this.student1Bean = student1Bean;
	}


	//bi-directional many-to-one association to Student
	@ManyToOne
	@JoinColumn(name="STUDENT2")
	public Student getStudent2Bean() {
		return this.student2Bean;
	}

	public void setStudent2Bean(Student student2Bean) {
		this.student2Bean = student2Bean;
	}


	//bi-directional many-to-one association to Student
	@ManyToOne
	@JoinColumn(name="STUDENT3")
	public Student getStudent3Bean() {
		return this.student3Bean;
	}

	public void setStudent3Bean(Student student3Bean) {
		this.student3Bean = student3Bean;
	}
	
	public static String getDefaultSortOrder()
	{
		return "titel";
	}	
	
	private int version;	
	@Version
	public int getVersion() {
		return this.version;
	}

	public void setVersion(int version) {
		this.version = version;
	}

	@Override
	public String getName() {
		return this.titel;
	}		
}