package databaseModel;

import javax.persistence.*;
import javax.validation.constraints.NotNull;

import org.hibernate.validator.constraints.Length;

import java.util.List;


/**
 * The persistent class for the UNTERNEHMEN database table.
 * 
 */
@Entity
public class Unternehmen extends AbstractEntity {
	private static final long serialVersionUID = 1L;
	private int id;
	@Length(max = 30, message="Der Name darf maximal 30 Zeichen lang sein")
	@NotNull		
	private String name;
	private List<Ansprechpartner> ansprechpartners;

	public Unternehmen() {
	}	

	@Id
	@GeneratedValue(strategy=GenerationType.IDENTITY)
	public int getId() {
		return this.id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return this.name;
	}

	public void setName(String name) {
		this.name = name;
	}


	//bi-directional many-to-one association to Ansprechpartner
	@OneToMany(mappedBy="unternehmenBean")
	public List<Ansprechpartner> getAnsprechpartners() {
		return this.ansprechpartners;
	}

	public void setAnsprechpartners(List<Ansprechpartner> ansprechpartners) {
		this.ansprechpartners = ansprechpartners;
	}
	
	public static String getDefaultSortOrder()
	{
		return "name";
	}
	
	private int version;	
	@Version
	public int getVersion() {
		return this.version;
	}

	public void setVersion(int version) {
		this.version = version;
	}		
}